using System;
using System.Collections.Generic;
using System.Security.Cryptography.X509Certificates;
using Jypeli;
using Jypeli.Assets;
using Jypeli.Controls;
using Jypeli.Widgets;

namespace matopeli;

/// @author Omanimi
/// @version 30.10.2023
/// <summary>
/// 
/// </summary>
public class matopeli : PhysicsGame
{
    private static readonly string[] tasonkuva = {
        "#################",
        "#               #",
        "#               #",
        "#               #",
        "#               #",
        "#               #",
        "#               #", 
        "#               #",
        "#               #",
        "#               #",
        "#               #",
        "#               #",
        "#               #",
        "#################",
    };
    private Objektit Mato;
    private Objektit Omena;
    
    public double MatoX;
    public double MatoY;

    public int LuoOmenaX;
    public int LuoOmenaY;
    
    public int SuuntaX;
    public int SuuntaY;

    public int leveys = 60;
    public int korkeus = 60;
    
    private static readonly Image seinakuva = LoadImage("seina.png");
    private static readonly Image matopaakuva = LoadImage("matopaa.png");
    private readonly Image matokehokuva = LoadImage("matokeho.png");
    private readonly Image omenakuva = LoadImage("omena.png");
    private readonly Image kenttatausta = LoadImage("kenttatausta.png");
    
    private bool SuuntaYlos = false;
    private bool SuuntaAlas = false;
    private bool SuuntaOikea = false;
    private bool SuuntaVasen = false;

    private bool OmenaKentalla = false;
    public override void Begin()
    {
        // Kirjoita ohjelmakoodisi tähän

        PhoneBackButton.Listen(ConfirmExit, "Lopeta peli");
        Keyboard.Listen(Key.Escape, ButtonState.Pressed, ConfirmExit, "Lopeta peli");
        AloitaUusiPeli();
        
    }

    public void AloitaUusiPeli()
    {
        Level.CreateBorders(0.0,true,Color.Green);
        ClearAll();
        SuuntaAlas = true;
        LuoMato();
        Asetaohjaimet();
        LuoAikalaskuri();
        
        TileMap tiles = TileMap.FromStringArray(tasonkuva);
        tiles['#'] = LuoSeina;
        tiles.Insert(leveys,korkeus);
    }
    private void Asetaohjaimet()
    {
        Keyboard.Listen(Key.Up, ButtonState.Pressed, VaihdaSuuntaYlos, "Turn upwards");
        Keyboard.Listen(Key.Down, ButtonState.Pressed, VaihdaSuuntaAlas, "Turn downwards");
        Keyboard.Listen(Key.Left, ButtonState.Pressed, VaihdaSuuntaVasen , "Turn left");
        Keyboard.Listen(Key.Right, ButtonState.Pressed, VaihdaSuuntaOikea, "Turn right");
    }
    private PhysicsObject LuoMato()
    {
        Mato = new Objektit(leveys, korkeus, new Vector(0,0));
        Mato.Image = matopaakuva;
        Add(Mato);
        Mato.Tag = "mato";
        AddCollisionHandler(Mato, "omena", delegate(IPhysicsObject Mato, IPhysicsObject Omena) {MatoSyoOmenan();  });
        return Mato;
    }

    private PhysicsObject LuoOmena()
    {
        Vector paikka = Level.GetRandomPosition();
        if (paikka.X-Mato.X<20)
        {
            if (paikka.Y-Mato.Y<20)
            {
                paikka = Level.GetRandomPosition();
            }
        }
        
        Omena = new Objektit(korkeus, leveys, paikka);
        Omena.Shape = Shape.Circle;
        Omena.Position = paikka;
        Omena.Image = omenakuva;
        Omena.Tag = "omena";
        Add(Omena);
        OmenaKentalla = true;
        return Omena;
    }
    private PhysicsObject LuoSeina()
    {
        PhysicsObject Seina = PhysicsObject.CreateStaticObject(leveys, korkeus);
        Seina.Color = Color.Green;
        Seina.Image = seinakuva;
        Seina.Tag = "seina";
        return Seina;
    }
    
    private void MatoSyoOmenan()
    {
        Omena.Destroy();
        OmenaKentalla = false;
    }
    
     private void VaihdaSuuntaYlos()
        {
            
            if (SuuntaAlas==true)
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = true;
            }
            else
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = true;
                SuuntaAlas = false;
            }
        }
     
     private void VaihdaSuuntaAlas()
        {
            if (SuuntaYlos==true)
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = true;
                SuuntaAlas = false;
            }
            else
            {
                SuuntaOikea = false;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = true;
            }
        }
        
     private void VaihdaSuuntaOikea()
        {
            if (SuuntaVasen == true)
            {
                
                SuuntaOikea = false;
                SuuntaVasen = true;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }
            else
            {
                SuuntaOikea = true;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }

        }
        
     private void VaihdaSuuntaVasen()
        {
            if (SuuntaOikea==true)
            {
                SuuntaOikea = true;
                SuuntaVasen = false;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }
            else
            {
                SuuntaOikea = false;
                SuuntaVasen = true;
                SuuntaYlos = false;
                SuuntaAlas = false;
            }
        }
     private void LuoAikalaskuri()
        {
            Timer aikalaskuri = new Timer();
            aikalaskuri.Interval = 0.01;
            aikalaskuri.Timeout += PaivitaKentta;
            aikalaskuri.Start();
        }

     private void PaivitaKentta()
     {
         if (Math.Abs(Mato.X)-Math.Abs(Mato.X)<0.001 && Math.Abs(Mato.Y)-Math.Abs(Mato.Y)<0.001)
         {
             LiikutaMatoa();
         }
         
         if (OmenaKentalla == false)
         {
             LuoOmena();
             //KasvataMatoa();
         }
     }

    private void LiikutaMatoa()
    {
        if (SuuntaYlos==true)
        {
            Mato.Y++;
            Mato.Angle = Angle.FromDegrees(90);
        }
        if (SuuntaAlas==true)
        {
            Mato.Y--;
            Mato.Angle = Angle.FromDegrees(270);
        }
        if (SuuntaOikea==true)
        {
            Mato.X++;
            Mato.Angle = Angle.FromDegrees(0);
        }
        if (SuuntaVasen==true)
        {
            Mato.X--;
            Mato.Angle = Angle.FromDegrees(180);
        }
        

    }

    private class Objektit : PhysicsObject
    {
         public Objektit(double leveys, double korkeus, Vector paikka)
        : base(leveys, korkeus)
        {
            Mass = 10000;
            IsUpdated = true;
        }
    }



}

        





        




    